<template lang="pug">
    v-card
        v-card-title Deposit
        v-card-text
            question(
                v-for="question in questions"
                :question="question"
                @input="grabChange(question.name, $event)"
            )
            v-subheader Finds
            v-divider
            div.row
                div.col-sm-6.col-md-3(
                    v-for="group in finds"
                )
                    question(
                        v-for="question in group"
                        :question="question"
                        @input="grabChange(question.name, $event)"
                    )
</template>

<script>
import question from "../Question_Wrapper.vue";
export default {
    name: "deposit",
    props: {
        options: {
            required: true,
            type: Object
        },
        deposit: {
            required: true
        }
    },
    data: function() {
        return {
            localDeposit: null,
            questions: [
                {
                    type: "text",
                    label: "Compaction",
                    value: this.deposit.compaction,
                    name: "compaction"
                },
                {
                    type: "text",
                    label: "Colour",
                    value: this.deposit.colour,
                    name: "colour"
                },
                {
                    type: "text",
                    label: "Composition",
                    value: this.deposit.composition,
                    name: "composition"
                },
                {
                    type: "text",
                    label: "Inclusions",
                    value: this.deposit.inclusions,
                    name: "inclusions"
                },
                {
                    type: "text",
                    label: "Thickness",
                    value: this.deposit.thickness,
                    name: "thickness"
                },
                {
                    type: "text",
                    label: "Weather",
                    value: this.deposit.weather,
                    name: "weather"
                },
                {
                    type: "text",
                    label: "Method",
                    value: this.deposit.method,
                    name: "method"
                },
                {
                    type: "select",
                    label: "Interpretation",
                    options: this.options.interpretations,
                    value: this.deposit.interpretation,
                    name: "interpretation"
                },
                {
                    type: "textArea",
                    label: "Interpretaion Comment",
                    value: this.deposit.interpretation_comment,
                    name: "interpretation_comment"
                },
                {
                    type: "textArea",
                    label: "discussion",
                    value: this.deposit.disscussion,
                    name: "disscussion"
                },
                {
                    type: "textArea",
                    label: "Comments",
                    value: this.deposit.comment,
                    name: "comments"
                }
            ],
            finds: {
                group_1: [
                    {
                        name: "finds_none",
                        type: "checkbox",
                        label: "None",
                        value: this.deposit.finds_none
                    },
                    {
                        name: "finds_pot",
                        type: "checkbox",
                        label: "Pot",
                        value: this.deposit.finds_pot
                    },
                    {
                        name: "finds_bone",
                        type: "checkbox",
                        label: "Bone",
                        value: this.deposit.finds_bone
                    }
                ],
                group_2: [
                    {
                        name: "finds_glass",
                        type: "checkbox",
                        label: "Glass",
                        value: this.deposit.finds_glass
                    },
                    {
                        name: "finds_metal",
                        type: "checkbox",
                        label: "Metal",
                        value: this.deposit.finds_metal
                    }
                ],
                group_3: [
                    {
                        name: "finds_cbm",
                        type: "checkbox",
                        label: "CBM",
                        value: this.deposit.finds_cbm
                    },
                    {
                        name: "finds_other_bm",
                        type: "checkbox",
                        label: "Other BM",
                        value: this.deposit.finds_other_cbm
                    }
                ],
                group_4: [
                    {
                        name: "finds_wood",
                        type: "checkbox",
                        label: "Wood",
                        value: this.deposit.finds_wood
                    },
                    {
                        name: "finds_leather",
                        type: "checkbox",
                        label: "Leather",
                        value: this.deposit.finds_leather
                    }
                ]
            }
        };
    },
    created() {
        this.localDeposit = this.deposit;
    },
    methods: {
        valueChanged() {
            this.$emit("input", {
                context: "Deposit",
                data: this.localDeposit
            });
        },
        grabChange(element, value) {
            this.localDeposit[element] = value;
            this.valueChanged();
        }
    },
    components: {
        question
    }
};
</script>
